<template>
	<div>
		<!-- Navigation para admin -->
		<v-card v-if="userType === 0">
			<!-- Drawer para pc -->
			<v-navigation-drawer
				app
				color="#c51f2f"
				dark
				expand-on-hover
				permanent
				v-if="breakpoint.name !== 'xs'"
				width="265"
			>
				<template v-slot:prepend>
					<v-toolbar color="grey lighten-3"></v-toolbar>
				</template>
				<v-list nav>
					<v-list-item to="/solicitudes">
						<v-list-item-icon>
							<v-icon>fas fa-users</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Solicitudes</v-list-item-title>
					</v-list-item>
					<v-list-item @click="openFormNewAdmin">
						<v-list-item-icon>
							<v-icon>fas fa-plus-circle</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Nuevo administrador</v-list-item-title>
					</v-list-item>
					<v-list-item to="/puntajes">
						<v-list-item-icon>
							<v-icon>fas fa-pencil-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Puntajes</v-list-item-title>
					</v-list-item>
					<v-list-item to="/estadísticas">
						<v-list-item-icon>
							<v-icon>fas fa-chart-bar</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Estadísticas</v-list-item-title>
					</v-list-item>
					<v-list-item @click="openFormLimitDate">
						<v-list-item-icon>
							<v-icon>fas fa-calendar-check</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Establecer fecha</v-list-item-title>
					</v-list-item>
					<v-divider></v-divider>
					<v-list-item @click="logout">
						<v-list-item-icon>
							<v-icon>fas fa-sign-out-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Cerrar sesión</v-list-item-title>
					</v-list-item>
				</v-list>
			</v-navigation-drawer>

			<!-- Drawer para movil -->
			<v-navigation-drawer
				app
				v-model="displayDrawer"
				color="#c51f2f"
				temporary
				dark
				stateless
				width="265"
				v-else
			>
				<template v-slot:prepend>
					<v-toolbar color="white">
						<img src="../assets/cozcytLogoDra.png" />
						<v-spacer></v-spacer>
						<v-btn icon color="#c51f2f" text @click="closeDrawer">
							<v-icon>fas fa-chevron-left</v-icon>
						</v-btn>
					</v-toolbar>
				</template>
				<v-list nav>
					<v-list-item to="/solicitudes">
						<v-list-item-icon>
							<v-icon>fas fa-users</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Solicitudes</v-list-item-title>
					</v-list-item>
					<v-list-item @click="openFormNewAdmin">
						<v-list-item-icon>
							<v-icon>fas fa-plus-circle</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Nuevo administrador</v-list-item-title>
					</v-list-item>
					<v-list-item to="/puntajes">
						<v-list-item-icon>
							<v-icon>fas fa-pencil-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Puntajes</v-list-item-title>
					</v-list-item>
					<v-list-item to="/estadísticas">
						<v-list-item-icon>
							<v-icon>fas fa-chart-bar</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Estadísticas</v-list-item-title>
					</v-list-item>
					<v-list-item @click="openFormLimitDate">
						<v-list-item-icon>
							<v-icon>fas fa-calendar-check</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Establecer fecha</v-list-item-title>
					</v-list-item>
					<v-divider></v-divider>
					<v-list-item @click="logout">
						<v-list-item-icon>
							<v-icon>fas fa-sign-out-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Cerrar sesión</v-list-item-title>
					</v-list-item>
				</v-list>
			</v-navigation-drawer>
		</v-card>

		<!-- Navigation para estudiantes -->
		<v-card v-if="userType === 1">
			<!-- Drawer para pc -->
			<v-navigation-drawer
				app
				color="#c51f2f"
				dark
				expand-on-hover
				permanent
				v-if="breakpoint.name !== 'xs'"
				width="265"
			>
				<template v-slot:prepend>
					<v-toolbar color="grey lighten-3"></v-toolbar>
				</template>
				<v-list nav>
					<v-list-item link v-for="item in routesStudent" :key="item.name" :to="item.route">
						<v-list-item-icon>
							<v-icon>{{item.icon}}</v-icon>
						</v-list-item-icon>
						<v-list-item-title>{{item.name}}</v-list-item-title>
					</v-list-item>
					<v-list-item @click="showEconomicForm">
						<v-list-item-icon>
							<v-icon>fas fa-file-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Estudio socioeconómico</v-list-item-title>
					</v-list-item>
					<v-list-item to="/mensajes">
						<v-list-item-action>
							<v-badge color="#72a051">
								<span slot="badge" v-if="messages > 0">{{messages}}</span>
								<v-icon>fas fa-bell</v-icon>
							</v-badge>
						</v-list-item-action>
						<v-list-item-title>Mensajes</v-list-item-title>
					</v-list-item>
					<v-divider></v-divider>
					<v-list-item @click="logout">
						<v-list-item-icon>
							<v-icon>fas fa-sign-out-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Cerrar sesión</v-list-item-title>
					</v-list-item>
				</v-list>
			</v-navigation-drawer>

			<!-- Drawer para movil -->
			<v-navigation-drawer
				app
				v-model="displayDrawer"
				color="#c51f2f"
				temporary
				dark
				stateless
				width="265"
				v-else
			>
				<template v-slot:prepend>
					<v-toolbar color="white">
						<img src="../assets/cozcytLogoDra.png" />
						<v-spacer></v-spacer>
						<v-btn icon color="#c51f2f" text @click="closeDrawer">
							<v-icon>fas fa-chevron-left</v-icon>
						</v-btn>
					</v-toolbar>
				</template>
				<v-list nav>
					<v-list-item link v-for="item in routesStudent" :key="item.name" :to="item.route">
						<v-list-item-icon>
							<v-icon>{{item.icon}}</v-icon>
						</v-list-item-icon>
						<v-list-item-title>{{item.name}}</v-list-item-title>
					</v-list-item>
					<v-list-item @click="showEconomicForm">
						<v-list-item-icon>
							<v-icon>fas fa-file-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Estudio socioeconómico</v-list-item-title>
					</v-list-item>
					<v-list-item link to="/mensajes">
						<v-list-item-action>
							<v-badge color="#72a051">
								<span slot="badge" v-if="messages > 0">{{messages}}</span>
								<v-icon>fas fa-bell</v-icon>
							</v-badge>
						</v-list-item-action>
						<v-list-item-title>Mensajes</v-list-item-title>
					</v-list-item>
					<v-divider></v-divider>
					<v-list-item @click="logout">
						<v-list-item-icon>
							<v-icon>fas fa-sign-out-alt</v-icon>
						</v-list-item-icon>
						<v-list-item-title>Cerrar sesión</v-list-item-title>
					</v-list-item>
				</v-list>
			</v-navigation-drawer>
		</v-card>

		<FormNewAdmin :showDialog="visibleForm" />
		<FormEconomicData :showEconomicForm="visible" />
		<FormLimitDate :visibleForm="visibleFormLimitDate" />
		<Footer />
	</div>
</template>

<script>
import FormEconomicData from "@/components/student/FormEconomicData";
import FormNewAdmin from "@/components/admin/FormNewAdmin";
import Footer from '@/components/Footer.vue';
import FormLimitDate from "@/components/admin/FormLimitDate";
import EventBus from "../bus";
import { mapActions, mapState } from "vuex";

export default {
	name: "NavigationDrawer",
	props: ["displayDrawer"],
	components: { FormEconomicData, FormNewAdmin, FormLimitDate, Footer },
	data() {
		return {
			breakpoint: this.$vuetify.breakpoint,
			userType: 0,
			visible: false,
			visibleForm: false,
			visibleFormLimitDate: false,
			visibleScoreForm: false,
			routesStudent: [
				{ icon: "fas fa-user", name: "Perfil", route: "/perfil" },
				{
					icon: "fas fa-newspaper",
					name: "Convocatorias",
					route: "/convocatorias"
				},
				{
					icon: "fas fa-history",
					name: "Historial",
					route: "/solicitudes-de-beca"
				}
			],
			routesAdmin: [
				{
					icon: "fas fa-newspaper",
					name: "Solicitudes",
					route: "/solicitudes"
				}
			]
		};
	},
	computed: {
		...mapState(["userData", "messages"])
	},
	methods: {
		...mapActions(["logout"]),
		// Muestra el formulario socioeconomico
		showEconomicForm() {
			this.visible = true;
		},
		// Emite el evento para cerrar el drawer
		closeDrawer() {
			EventBus.$emit("closeDrawer");
		},
		// Abre el formulario del nuevo admin
		openFormNewAdmin() {
			this.visibleForm = true;
		},
		// Abre el formulario para establecer una fecha limite
		openFormLimitDate() {
			this.visibleFormLimitDate = true;
		}
	},
	mounted() {
		// Cierra el formulario del estudio socio economico
		this.userType = this.userData.type;
		EventBus.$on("closeEconomicForm", () => {
			this.visible = false;
		});

		EventBus.$on("closeFormNewAdmin", () => {
			this.visibleForm = false;
		});

		EventBus.$on("totalMessages", total => {
			this.messages = total;
		});

		EventBus.$on("closeFormLimitDate", () => {
			this.visibleFormLimitDate = false;
		});

		EventBus.$on("openFormEconomicStudy",() => {
			this.visible = true;
		})
	}
};
</script>

<style scope>
.a {
	display: flex;
	align-items: center;
}
.chiquito {
	font-size: 10px;
}
</style>